/* 
 * $RCSfile: xk_debug.c,v $
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 *
 * $Log: xk_debug.c,v $
 * Revision 1.2  1996/01/29 19:43:36  slm
 * Updated copyright and version.
 *
 * Revision 1.1  1995/07/28  21:41:44  slm
 * Initial revision
 *
 * Revision 1.18.1.1.1.1  1994/10/27  20:52:22  hkaram
 * New branch
 *
 * Revision 1.18.1.1  1994/03/14  23:05:19  umass
 * Size of errbuf is now a manifest constant
 */

#include "xk_debug.h"
#include "platform.h"
#ifndef XKMACHKERNEL
#include "x_stdio.h"
#endif /* XKMACHKERNEL */

#ifdef XK_DEBUG

int
  tracebuserror,
  tracecustom,
  traceether,
  traceevent,
  tracefixme,
  traceidle,
  traceie,
  tracememoryinit,
  traceprocesscreation,
  traceprocessswitch,
  traceprotocol,
  traceprottest,
  tracetick,
  tracetrap,
  traceuser;

char assertMessage[] = "Assertion failed: file %s, line %d\n";

#endif /* XK_DEBUG */

char  errBuf[GLOBAL_ERRBUF_SIZE];

void
xError( msg )
    char	*msg;
{
    xTraceLock();
#ifndef XKMACHKERNEL
    fprintf(stderr, "%s\n", msg);
#else
    printf("%s\n", msg);
#endif /* XKMACHKERNEL */
    xTraceUnlock();
}
