/*
 * trace.c
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 *
 * $Revision: 1.3 $
 * $Date: 1996/02/01 15:23:16 $
 * 
 * HISTORY
 * $Log: trace.c,v $
 * Revision 1.3  1996/02/01 15:23:16  slm
 * Updated copyright and version.
 *
 * Revision 1.2  1995/08/28  16:16:45  acb
 * Initial revision for x3.3
 *
 * Revision 1.1  1994/10/26  20:48:59  hkaram
 * Initial revision
 */

#include "platform.h"
#include "xk_debug.h"
#include "compose.h"

#ifdef XK_TRACE_LOCKING
static pthread_mutex_t lock;
#endif

void
xTraceLock(void)
{
#ifdef XK_TRACE_LOCKING
    pthread_mutex_lock( &lock );
#endif
}

void
xTraceUnlock(void)
{
#ifdef XK_TRACE_LOCKING
    pthread_mutex_unlock( &lock );
#endif
}

 

void
xTraceInit(void)
{
#ifdef XK_TRACE_LOCKING
    pthread_mutex_init( &lock, NULL );
    initTraceLevels();
#endif
}

